SystemOrganization addCategory: #'Magritte-Core'!
SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Accessor'!
SystemOrganization addCategory: #'Magritte-Core-Wrapper'!
SystemOrganization addCategory: #'Magritte-Core-Relation'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Exception'!
SystemOrganization addCategory: #'Magritte-Core-Utility'!

SmaCCScanner subclass: #MARelationScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationScanner class methodsFor: 'generated-initialization' stamp: 'lr 4/17/2005 19:08'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(10 'AND' 4) #(10 'NOT' 1) #(10 'OR' 5) #(10 'false' 6) #(10 'nil' 2) #(10 'true' 7)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!MARelationScanner class methodsFor: 'generated-comments' stamp: 'lr 4/17/2005 19:08'!
scannerDefinitionComment

	"<unary>			: [a-zA-Z] [a-zA-Z0-9]* ;
<number>		: [\-]? [0-9] [0-9]* ;
<string>			: \' [^\']* \' (\' [^\']* \')* ;
<keyword>		: <unary> \: ;
<binary>		: [\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]? ;
<whitespace>		: \s+ ;
<comment>		: \"" [^\""]* \"" ;"! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 4/17/2005 19:08'!
emptySymbolTokenId
	^30! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 4/17/2005 19:08'!
errorTokenId
	^31! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 4/17/2005 19:08'!
scan1
	
	[
	[self step.
	currentCharacter ~~ $'] whileTrue.
	self recordMatch: #(12).
	self step.
	currentCharacter == $'] 
			whileTrue: [].
	^self reportLastMatch! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 4/17/2005 19:08'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[
				[self recordMatch: #(10).
				self step.
				currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]] 
						whileTrue.
				currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(13)].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[(currentCharacter between: $< and: $@) or: 
											[currentCharacter == $\ 
												or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(11).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[
			[self step.
			currentCharacter ~~ $"] whileTrue.
			^self recordAndReportMatch: #comment].
	currentCharacter == $' ifTrue: [^self scan1].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(3 14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(11).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

Error subclass: #MAError
	instanceVariableNames: 'wrapper resumable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAConcurrentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
wrapper: aWrapper message: aString
	^ self wrapper: aWrapper message: aString resumable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
wrapper: aWrapper message: aString resumable: aBoolean
	^ self new
		wrapper: aWrapper;
		resumable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:14'!
accessor
	^ self wrapper accessor.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:14'!
description
	^ self wrapper owner.! !

!MAError methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isResumable
	^ self resumable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
resumable
	^ resumable! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
resumable: aBoolean
	resumable := aBoolean! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
wrapper
	^ wrapper! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
wrapper: aWrapper
	wrapper := aWrapper! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

Object subclass: #MABlockToRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MABlockToRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
do: aBlock
	^ aBlock value: self new.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
< anObject
	^ MASelectorRelation selector: #< with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
<= anObject
	^ MASelectorRelation selector: #<= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
= anObject
	^ MASelectorRelation selector: #= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
> anObject
	^ MASelectorRelation selector: #> with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
>= anObject
	^ MASelectorRelation selector: #>= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
beginsWith: anObject
	^ MASelectorRelation selector: #beginsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
between: aMinimum and: aMaximum 
	^ MASelectorRelation selector: #between:and: with: aMinimum with: aMaximum.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
endsWith: anObject
	^ MASelectorRelation selector: #endsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
includes: anObject
	^ MASelectorRelation selector: #includes: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
isEmpty
	^ MASelectorRelation selector: #isEmpty.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isEven
	^ MASelectorRelation selector: #even.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isFloat
	^ MASelectorRelation selector: #isFloat.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isInteger
	^ MASelectorRelation selector: #isInteger.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isNegative
	^ MASelectorRelation selector: #negative.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 4/18/2005 08:14'!
isNil
	^ MASelectorRelation selector: #isNil.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isOdd
	^ MASelectorRelation selector: #odd.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isPositive
	^ MASelectorRelation selector: #positive.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/18/2005 08:14'!
isZero
	^ MASelectorRelation selector: #isZero.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
matches: anObject
	^ MASelectorRelation selector: #matches:.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/18/2005 08:14'!
notEmpty
	^ MASelectorRelation selector: #notEmpty.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 4/18/2005 08:14'!
notNil
	^ MASelectorRelation selector: #notNil.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/18/2005 08:14'!
~= anObject
	^ MASelectorRelation selector: #~= with: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
default
	default isNil
		ifTrue: [ default := self new ].
	^ default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
build: anObject
	| description |
	^ anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				description isDescription
					ifTrue: [ container := container , description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isDescriptionSelector: aSelector
	^ aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
build: anObject
	^ self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
cache
	^ cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/18/2005 08:14'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/18/2005 08:14'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MAObject
	instanceVariableNames: 'hash properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core'!

MAObject subclass: #MAAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canRead
	^ true! !

!MAAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canWrite
	^ true! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printOn: aStream
	super printOn: aStream.
	self canRead ifTrue: [
		aStream nextPutAll: ' read: {'.
		self printRead: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].
	self canWrite ifTrue: [
		aStream nextPutAll: ' write: {'.
		self printWrite: 'anObject' to: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printRead: aModel on: aStream! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printWrite: anObject to: aModel on: aStream! !

!MAAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
read: aModel
	"Read from aModel using the description of the receiver."
	
	self subclassResponsibility.! !

!MAAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
write: anObject to: aModel
	"Write to aModel using the description of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
read: aReadBlock write: aWriteBlock
	^ self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canRead
	^ self readBlock notNil.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canWrite
	^ self writeBlock notNil.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printBlock: aBlock on: aStream
	aStream nextPutAll: aBlock decompile asString allButFirst allButLast.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printRead: aModel on: aStream
	self printBlock: self readBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printWrite: anObject to: aModel on: aStream
	self printBlock: self writeBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.
	aStream nextPutAll: ' value: '; nextPutAll: anObject asString.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
read: aModel
	^ self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
readBlock
	^ readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
writeBlock
	^ writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
accessor: anAccessor next: aNextAccessor
	^ self new
		accessor: anAccessor;
		next: aNextAccessor; 
		yourself.! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
selectors: anArray
	^ anArray allButLast reverse
		inject: (MASelectorAccessor selector: anArray last)
		into: [ :next :accessor | 
			self 
				accessor: (MASelectorAccessor selector: accessor)
				next: next ].! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
accessor
	^ accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canRead
	^ self next canRead.! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canWrite
	^ self next canWrite.! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
next
	^ next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printRead: aModel on: aStream
	self next 
		printRead: (String streamContents: [ :stream |
			self accessor 
				printRead: aModel 
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printWrite: anObject to: aModel on: aStream
	self next
		printWrite: anObject
		to: (String streamContents: [ :stream |
			self accessor
				printRead: aModel
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
read: aModel
	^ self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canWrite
	^ false! !

!MAContainerAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
read: aModel
	^ aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MANullAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canRead
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
canWrite
	^ false! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
read: aModel
	self error: 'Not supposed to read from ' , aModel asString , '.'.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:14'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
read: aReadSelector write: aWriteSelector
	^ self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector
	^ self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
canRead
	^ self readSelector notNil.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
canWrite
	^ self writeSelector notNil.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:15'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self readSelector.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 4/18/2005 08:15'!
printWrite: anObject to: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self writeSelector; space.
	aStream nextPutAll: anObject asString.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:15'!
read: aModel
	^ aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
readSelector
	^ readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
selector
	^ self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 4/18/2005 08:15'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
writeSelector
	^ writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAObject subclass: #MADescription
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultAccessor
	^ MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultCollection
	^ OrderedCollection new.! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
with: aDescription
	^ self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:14'!
acceptMagritte: aVisitor
	aVisitor visitContainer: self.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 4/18/2005 08:14'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 4/18/2005 08:14'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
asContainer
	^ self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
children
	^ children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
collect: aBlock
	^ self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
copyFrom: aStartIndex to: anEndIndex
	^ self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
copyInto: aDictionary
	^ aDictionary at: self put: (self copy 
		setChildren: (self children 
			collect: [ :each | each copyInto: aDictionary ])).! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
detect: aBlock 
	^ self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
detect: aBlock ifNone: anExceptionBlock 
	^ self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasChildren
	^ self notEmpty.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
includes: aDescription
	^ self children includes: aDescription.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
initialize
	super initialize.
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
inject: anObject into: aBlock 
	^ self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isContainer	
	^ true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isEmpty
	^ self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/18/2005 08:14'!
moveDown: aDescription
	self children moveDown: aDescription.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/18/2005 08:14'!
moveUp: aDescription
	self children moveUp: aDescription.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
notEmpty
	^ self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
reject: aBlock
	^ self copy 
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 4/18/2005 08:14'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 4/18/2005 08:14'!
removeAll
	children := self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
select: aBlock
	^ self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
size
	^ self children size.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/18/2005 08:14'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultCollection
	^ SortedCollection new.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/18/2005 08:14'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/18/2005 08:14'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
resort
	self setChildren: self children copy.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 4/18/2005 08:15'!
defaultCaption
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 4/18/2005 08:15'!
defaultEmpty
	^ 'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 4/18/2005 08:15'!
defaultPageSize
	^ 10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultShowBatch
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultShowFooter
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultShowHeader
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 4/18/2005 08:15'!
defaultSummary
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 4/18/2005 08:15'!
descriptionCaption
	^ MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 4/18/2005 08:15'!
descriptionEmpty
	^ MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 4/18/2005 08:15'!
descriptionPageSize
	^ MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionShowBatch
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionShowFooter
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionShowHeader
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 4/18/2005 08:15'!
descriptionSummary
	^ MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
caption
	^ self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
empty
	^ self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 4/18/2005 08:15'!
pageSize
	^ self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 4/18/2005 08:15'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showBatch
	^ self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showFooter
	^ self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showHeader
	^ self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
summary
	^ self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 4/18/2005 08:15'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ super asLabel allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultAccessor
	^ MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultComment
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultCondition
	^ MAConstantRelation true.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultLabel
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultPersistent
	^ true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultPriority
	^ 0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultReadonly
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultRequired
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultVisible
	^ true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionComment
	^ MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionLabel
	^ MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionPersistent
	^ MABooleanDescription selector: #persistent label: 'Persistent' priority: 330 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionPriority
	^ MANumberDescription selector: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionReadonly
	^ MABooleanDescription selector: #readonly label: 'Readonly' priority: 300 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionRequired
	^ MABooleanDescription selector: #required label: 'Required' priority: 320 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionVisible
	^ MABooleanDescription selector: #visible label: 'Visible' priority: 310 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MADescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^ self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^ self priority <= anObject priority.! !

!MADescription methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:14'!
acceptMagritte: aVisitor
	aVisitor visitDescription: self.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessor ].
	^ accessor.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
accessor: anAccessor	
	accessor := anAccessor! !

!MADescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
comment	
	^ self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
condition	
	^ self propertyAt: #condition ifAbsent: [ self class defaultCondition ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
condition: aCondition
	self propertyAt: #condition put: ((aCondition isKindOf: BlockContext)
		ifTrue: [ MABlockToRelation do: aCondition ]
		ifFalse: [ aCondition ]).! !

!MADescription methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
copyInto: aDictionary
	^ aDictionary at: self put: self copy.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasChildren
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasComment
	^ (self propertyAt: #comment ifAbsent: [ ^ false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasCondition
	^ self propertyAt: #condition ifAbsent: [ ^ false ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasLabel
	^ (self propertyAt: #label ifAbsent: [ ^ false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isContainer	
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isDescription
	^ true! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isPersistent
	^ self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isReadonly
	^ self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isRequired
	^ self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	"Return true or false wheter anObject is a proper value of the receiver."

	^ (anObject isKindOf: self kind)
		and: [ self condition isSatisfiedBy: anObject ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isVisible
	^ self visible.! !

!MADescription methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
key
	^ [ self accessor selector ]
		on: Error
		do: [ :err | nil ].! !

!MADescription methodsFor: 'accessing-configuration' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Object! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
label	
	^ self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
persistent	
	^ self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
postCopy
	super postCopy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
priority
	^ self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
readonly	
	^ self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
required	
	^ self propertyAt: #required 	ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
visible	
	^ self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinaryDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Upload'! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ ByteArray! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
parseString: aString
	^ self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Check-Box'! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Boolean! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
parseString: aString
	^ self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^ true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^ false ].
		aString ].! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/18/2005 08:15'!
accessor: anAccessor
	^ self accessor: anAccessor label: self defaultLabel.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/18/2005 08:15'!
accessor: anAccessor label: aString
	^ self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/18/2005 08:15'!
accessor: anAccessor label: aString priority: aNumber
	^ self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/18/2005 08:15'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^ self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MAElementDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultDefault
	^ nil! !

!MAElementDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionDefault
	^ self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 200 default: self defaultDefault ].! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/18/2005 08:15'!
read: aReadBlock write: aWriteBlock
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/18/2005 08:15'!
read: aReadBlock write: aWriteBlock label: aString
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/18/2005 08:15'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/18/2005 08:15'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector
	^ self accessor: (MASelectorAccessor selector: aSelector).! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector label: aString
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector label: aString priority: aNumber
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/18/2005 08:15'!
selectors: anArray
	^ self accessor: (MACascadeAccessor selectors: anArray).! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/18/2005 08:15'!
selectors: anArray label: aString
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/18/2005 08:15'!
selectors: anArray label: aString priority: aNumber
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/18/2005 08:15'!
selectors: anArray label: aString priority: aNumber default: anObject
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MAElementDescription methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:14'!
acceptMagritte: aVisitor
	aVisitor visitElement: self.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
asContainer
	^ MAContainer with: self.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
collectionToString: aCollection
	^ String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: (self toString: each) ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
default
	^ default! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
default: anObject
	default := anObject! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
parseString: aString
	^ self parseString: aString protected: [ aString ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
parseString: aString protected: aBlock
	^ aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self default: self default copy.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
stringToCollection: aString default: aCollection
	^ aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			(((aString findTokens: Character cr)
				collect: [ :each | each withBlanksCondensed ])
					select: [ :each | each notEmpty ])
						collect: [ :each | self parseString: each ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
toString: anObject
	^ anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asLabel ].! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Duration! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
parseString: aString
	^ self parseString: aString protected: [ self kind fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Number! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:14'!
parseString: aString
	^ self parseString: aString protected: [ aString asNumber ].! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
kind
	^ Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
kind
	^ TimeStamp! !

MAElementDescription subclass: #MASelectionDescription
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MASelectionDescription subclass: #MAMultipleSelectionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAMultipleSelectionDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Multiple-Selection'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultAvailableLabel
	^ 'Available'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultOrdered
	^ true! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultSelectedLabel
	^ 'Selected'! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultUnique
	^ true! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionAvailableLabel
	^ MAStringDescription selector: #availableLabel label: 'Available Label' priority: 380.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionOrdered
	^ MABooleanDescription selector: #ordered label: 'Ordered' priority: 470.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionSelectedLabel
	^ MAStringDescription selector: #selectedLabel label: 'Selected Label' priority: 390.! !

!MAMultipleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionUnique
	^ MABooleanDescription selector: #unique label: 'Unique' priority: 460.! !

!MAMultipleSelectionDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
add: anObject to: aCollection
	anObject isNil
		ifTrue: [ ^ self ].
	(self isUnique and: [ aCollection includes: anObject ])
		ifTrue: [ ^ self ]. 
	aCollection add: anObject.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
availableLabel
	^ self propertyAt: #availableLabel ifAbsent: [ self class defaultAvailableLabel ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
availableLabel: aString
	^ self propertyAt: #availableLabel put: aString.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beMultiple
	self unique: false.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beOrdered
	self ordered: true.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beUnique
	self unique: true.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
beUnordered
	self ordered: false.! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isOrdered
	^ self ordered.! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject) and: [ 
		anObject allSatisfy: [ :each | 
			self options includes: each ] ].! !

!MAMultipleSelectionDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isUnique
	^ self unique.! !

!MAMultipleSelectionDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
kind
	^ Collection! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
ordered
	^ self propertyAt: #ordered ifAbsentPut: [ self class defaultOrdered ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
ordered: aBoolean
	^ self propertyAt: #ordered put: aBoolean.! !

!MAMultipleSelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:14'!
remove: anObject from: aCollection
	anObject isNil
		ifTrue: [ ^ self ].
	aCollection remove: anObject ifAbsent: nil.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
selectedLabel
	^ self propertyAt: #selectedLabel ifAbsent: [ self class defaultSelectedLabel ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
selectedLabel: aString
	^ self propertyAt: #selectedLabel put: aString.! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
unique
	^ self propertyAt: #unique ifAbsentPut: [ self class defaultUnique ].! !

!MAMultipleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:14'!
unique: aBoolean
	^ self propertyAt: #unique put: aBoolean.! !

!MASelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultOptions
	^ OrderedCollection new.! !

!MASelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultSorted
	^ false! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionDefault
	^ nil! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionOptions
	^ MATextDescription selector: #optionsTextual label: 'Options' priority: 400.! !

!MASelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionSorted
	^ MABooleanDescription selector: #sorted label: 'Sorted' priority: 450.! !

!MASelectionDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
allOptions
	^ Array streamContents: [ :stream |
		self isSorted
			ifFalse: [ stream nextPutAll: self options ]
			ifTrue: [ 
				stream nextPutAll: (self options asSortedCollection: [ :a :b | 
					(a asLabel compare: b asLabel) <= 2 ]) ] ].! !

!MASelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:15'!
beSorted
	self sorted: true.! !

!MASelectionDescription methodsFor: 'actions' stamp: 'lr 4/18/2005 08:15'!
beUnsorted
	self sorted: false.! !

!MASelectionDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isSorted
	^ self sorted.! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
options
	^ options ifNil: [ options := self class defaultOptions ].! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
options: aCollection
	options := aCollection! !

!MASelectionDescription methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
optionsTextual
	^ self collectionToString: self options.! !

!MASelectionDescription methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MASelectionDescription methodsFor: 'copying' stamp: 'lr 4/18/2005 08:15'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
sorted
	^ self propertyAt: #sorted ifAbsentPut: [ self class defaultSorted ].! !

!MASelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
sorted: aBoolean
	self propertyAt: #sorted put: aBoolean.! !

MASelectionDescription subclass: #MASingleSelectionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASingleSelectionDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Single-Selection'! !

!MASingleSelectionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultNilLabel
	^ String new.! !

!MASingleSelectionDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionNilLabel
	^ MAStringDescription selector: #nilLabel label: 'Nil Label' priority: 390.! !

!MASingleSelectionDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MASingleSelectionDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
allOptions
	^ Array streamContents: [ :stream |
		self isRequired 
			ifFalse: [ stream nextPut: nil ].
		stream nextPutAll: super allOptions ].! !

!MASingleSelectionDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self options includes: anObject ].! !

!MASingleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
nilLabel
	^ self propertyAt: #nilLabel ifAbsentPut: [ self class defaultNilLabel ].! !

!MASingleSelectionDescription methodsFor: 'accessing-properties' stamp: 'lr 4/18/2005 08:15'!
nilLabel: aString
	^ self propertyAt: #nilLabel put: aString.! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isObfuscated: anObject
	^ anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
obfuscated: anObject
	^ String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
kind
	^ String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Symbol Field'! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
kind
	^ Symbol! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
parseString: aString
	^ self parseString: aString protected: [ aString asSymbol ].! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATableDescription class methodsFor: 'converting' stamp: 'lr 4/18/2005 08:15'!
asLabel
	^ 'Table'! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultCellDescription
	^ self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultCellDescriptionClasses
	^ Array 
		with: MAStringDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultColumnLabels
	^ OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
defaultRowLables
	^ OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionCellDescription
	^ (MASingleSelectionDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionColumnLabels
	^ MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionDefault
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionRequired
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 4/18/2005 08:15'!
descriptionRowLabels
	^ MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
cellCount
	^ self columnCount * self rowCount.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^ cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
columnCount
	^ self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^ columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 4/18/2005 08:15'!
columnLabelsTextual
	^ self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 4/18/2005 08:15'!
columnLabelsTextual: aString
	^ self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 4/18/2005 08:15'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^ index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 4/18/2005 08:15'!
indexAt: aRowIndex at: aColIndex 
	^ ((aRowIndex - 1) * self columnCount) + aColIndex.! !

!MATableDescription methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
kind
	^ SequenceableCollection! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 4/18/2005 08:15'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
rowCount
	^ self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^ rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 4/18/2005 08:15'!
rowLabelsTextual
	^ self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 4/18/2005 08:15'!
rowLabelsTextual: aString
	^ self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 4/18/2005 08:15'!
rowOfIndex: anInteger
	^ anInteger - 1 // self columnCount + 1.! !

!MAObject class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ true! !

!MAObject class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MAObject methodsFor: 'comparing' stamp: 'lr 4/18/2005 08:14'!
= anObject
	"Compare the receiver with the argument and answer with true if the receiver is equal to the argument. Note that this test doesn't necessarily give back the right results, but presumably in most cases it does."
	
	^ super = anObject 
		or: [ self isSameAs: anObject ].! !

!MAObject methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:14'!
acceptMagritte: aVisitor! !

!MAObject methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasProperties
	^ properties notNil
		and: [ properties notEmpty ].! !

!MAObject methodsFor: 'comparing' stamp: 'lr 4/18/2005 08:14'!
hash
	^ hash! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
initialize
	super initialize.
	self initializeHash.! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
initializeHash
	"Create a new hash number to identify the receiver. This method is as a replacement to set a user defined identity hash of object."

	self setHash: SmallInteger maxVal atRandom.! !

!MAObject methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
inlcudesProperty: aKey
	^ self hasProperties
		and: [ self properties includesKey: aKey ].! !

!MAObject methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
isSameAs: anObject
	"Return true if the receiver and anObject are of the same type and share the same hash. In this case the two objects are presumably the same."
	
	^ self species = anObject species
		and: [ self hash = anObject hash ].! !

!MAObject methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
postCopy
	super postCopy. 
	self initializeHash.
	properties := properties copy.! !

!MAObject methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self hash; nextPut: $].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^ properties.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
propertyAt: aKey
	^ self properties at: aKey.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setHash: anInteger
	hash := anInteger! !

MAObject subclass: #MARelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelation commentStamp: '<historical>' prior: 0!
I represent an immutable relation. Users usually want to check if the relation I am representing is satisfied by sending the message #isSatisfiedBy:!

MARelation subclass: #MABasicRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MABasicRelation subclass: #MAConstantRelation
	instanceVariableNames: 'value'
	classVariableNames: 'FalseRelation TrueRelation'
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
false
	^ FalseRelation! !

!MAConstantRelation class methodsFor: 'class initialization' stamp: 'lr 4/18/2005 08:15'!
initialize
	TrueRelation := self new
		setHash: 252319986;
		setValue: true;
		yourself.
	FalseRelation := self new
		setHash: 535543701;
		setValue: false;
		yourself.! !

!MAConstantRelation class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
true
	^ TrueRelation! !

!MAConstantRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ self value.! !

!MAConstantRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setValue: aBoolean
	value := aBoolean! !

!MAConstantRelation methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
value
	^ value! !

MABasicRelation subclass: #MASelectorRelation
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MASelectorRelation subclass: #MAAccessorRelation
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAccessorRelation methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
accessor
	^ accessor! !

!MAAccessorRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ super isSatisfiedBy: (self accessor read: anObject).! !

!MAAccessorRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setAccessor: anAccessor
	accessor := anAccessor! !

MASelectorRelation subclass: #MAQueryRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAQueryRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ super isSatisfiedBy: anObject query.! !

!MASelectorRelation class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector
	^ self selector: aSelector arguments: Array new.! !

!MASelectorRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector arguments: aCollection
	^ self new
		setSelector: aSelector;
		setArguments: aCollection;
		yourself.! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector with: anObject
	^ self selector: aSelector arguments: (Array with: anObject).! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/18/2005 08:15'!
selector: aSelector with: aFirstObject with: aSecondObject
	^ self selector: aSelector arguments: (Array with: aFirstObject with: aSecondObject).! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
arguments
	^ arguments! !

!MASelectorRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isSatisfiedBy: anObject
	^ anObject perform: self selector withArguments: self arguments.! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
selector
	^ selector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setArguments: aCollection
	arguments := aCollection! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setSelector: aSelector
	selector := aSelector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setSelector: aSelector argument: anObject
	self setSelector: (self selector , aSelector) asSymbol.
	self setArguments: (self arguments copyWith: anObject).! !

MARelation subclass: #MAComposedRelation
	instanceVariableNames: 'relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MAComposedRelation subclass: #MAAllRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAllRelation class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAAllRelation methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
& aRelation
	^ self copyWith: aRelation.! !

!MAAllRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ self relations allSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

MAComposedRelation subclass: #MAAnyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAnyRelation class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAAnyRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ self relations anySatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MAAnyRelation methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
| aRelation
	^ self copyWith: aRelation.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
new
	^ super new
		setRelations: Array new;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
with: aRelation
	^ self withAll: (Array with: aRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
with: aFirstRelation with: aSecondRelation
	^ self withAll: (Array with: aFirstRelation with: aSecondRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
withAll: anArray
	^ self new
		setRelations: anArray;
		yourself.! !

!MAComposedRelation methodsFor: 'copying' stamp: 'lr 4/18/2005 08:14'!
copyWith: aRelation
	^ self class withAll: (self relations copyWith: aRelation).! !

!MAComposedRelation methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
relations
	^ relations! !

!MAComposedRelation methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setRelations: aCollection
	relations := aCollection! !

MAComposedRelation subclass: #MANoneRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MANoneRelation class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MANoneRelation methodsFor: 'operators' stamp: 'lr 4/18/2005 08:14'!
!! aRelation
	^ self copyWith: aRelation.! !

!MANoneRelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	^ self relations noneSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/18/2005 08:14'!
!! aRelation
	^ MANoneRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/18/2005 08:14'!
& aRelation
	^ MAAllRelation with: self with: aRelation.! !

!MARelation methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isSatisfiedBy: anObject
	self subclassResponsibility.! !

!MARelation methodsFor: 'operators-unary' stamp: 'lr 4/18/2005 08:14'!
not
	^ MANoneRelation with: self.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/18/2005 08:14'!
| aRelation
	^ MAAnyRelation with: self with: aRelation.! !

MAObject subclass: #MAWrapper
	instanceVariableNames: 'model owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Wrapper'!

MAWrapper subclass: #MACachedWrapper
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Wrapper'!

!MACachedWrapper class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
commit: anObject
	super commit: anObject.
	self push: anObject.! !

!MACachedWrapper methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasChanged
	^ self pull ~= self value.! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
reset: anObject
	super reset: anObject.
	self value: (self pull ifNil: [ self owner default ]) asCachedCopy.! !

!MACachedWrapper methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
setModel: aModel
	super setModel: aModel.
	self reset.! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
value
	^ value! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
value: anObject
	value := anObject! !

MACachedWrapper subclass: #MACheckedWrapper
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Wrapper'!

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
commit: anObject
	super commit: anObject.
	self original: self value.! !

!MACheckedWrapper methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
hasConflict
	^ self hasChanged
		and: [ self pull ~= self original ].! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
original
	^ original! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
original: anObject
	original := anObject! !

!MACheckedWrapper methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' original: '; print: self original.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
reset: anObject
	super reset: anObject.
	self original: self pull asCachedCopy.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
validate: anObject
	super validate: anObject.
	self hasConflict ifTrue: [ 
		self 
			reset: anObject; 
			errorConcurrent ].! !

MAWrapper subclass: #MAStraitWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Wrapper'!

!MAStraitWrapper class methodsFor: 'testing' stamp: 'lr 4/18/2005 08:15'!
isAbstract
	^ false! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
value
	^ self pull ifNil: [ self owner default ].! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
value: anObject
	self push: anObject.! !

!MAWrapper class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
on: aDescription model: aModel
	^ self new
		setOwner: aDescription;
		setModel: aModel;
		yourself.! !

!MAWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
accessor
	^ self owner accessor.! !

!MAWrapper methodsFor: 'actions' stamp: 'lr 4/18/2005 08:15'!
commit
	"Commit the value into the model."

	self owner isReadonly
		ifTrue: [ ^ self ].
	self notifyCommitBefore.
	self commit: self value.
	self notifyCommitAfter.! !

!MAWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
commit: anObject
	"Primitive to commit anObject to the model. Do not call directly, use #commit instead."! !

!MAWrapper methodsFor: 'errors' stamp: 'lr 4/18/2005 08:15'!
errorConcurrent
	MAConcurrentError wrapper: self message: 'Concurrent modification in ' , self owner asLabel.! !

!MAWrapper methodsFor: 'errors' stamp: 'lr 4/18/2005 08:15'!
errorReadonly
	MAReadonlyError wrapper: self message: self owner asLabel , ' is readonly.'.! !

!MAWrapper methodsFor: 'errors' stamp: 'lr 4/18/2005 08:15'!
errorRequired
	MARequiredError wrapper: self message: self owner asLabel , ' is required.'.! !

!MAWrapper methodsFor: 'errors' stamp: 'lr 4/18/2005 08:15'!
errorValidation
	MAValidationError wrapper: self message: self owner asLabel , ' is invalid.'.! !

!MAWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
model
	^ model! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyCommitAfter
	MACommitNotification notifyAfter: self.! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyCommitBefore
	MACommitNotification notifyBefore: self.! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyResetAfter
	MAResetNotification notifyAfter: self.! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyResetBefore
	MAResetNotification notifyBefore: self.! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyValidateAfter
	MAValidateNotification notifyAfter: self.! !

!MAWrapper methodsFor: 'notification' stamp: 'lr 4/18/2005 08:15'!
notifyValidateBefore
	MAValidateNotification notifyBefore: self.! !

!MAWrapper methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
owner
	^ owner! !

!MAWrapper methodsFor: 'copying' stamp: 'lr 4/18/2005 08:15'!
postCopy
	super postCopy.
	self setOwner: nil.! !

!MAWrapper methodsFor: 'printing' stamp: 'lr 4/18/2005 08:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' value: '; print: self value.! !

!MAWrapper methodsFor: 'private-model' stamp: 'lr 4/18/2005 08:15'!
pull
	"Primitive to read from the model. Do not call directly, use #value instead."

	^ self model readUsing: self owner.! !

!MAWrapper methodsFor: 'private-model' stamp: 'lr 4/18/2005 08:15'!
push: anObject
	"Primitive to write to the model. Do not call directly, use #value: instead."

	self model write: anObject using: self owner.! !

!MAWrapper methodsFor: 'actions' stamp: 'lr 4/18/2005 08:15'!
reset
	"Resets the value to the one of the model."
	
	self notifyResetBefore.
	self reset: self value.
	self notifyResetAfter.! !

!MAWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
reset: anObject
	"Primitive to reset anObject. Do not call directly, use #reset instead."! !

!MAWrapper methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setModel: aModel
	model := aModel! !

!MAWrapper methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setOwner: aDescription
	owner := aDescription! !

!MAWrapper methodsFor: 'actions' stamp: 'lr 4/18/2005 08:15'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."

	self owner isReadonly 
		ifTrue: [ ^ self ].
	self notifyValidateBefore.
	self validate: self value.
	self notifyValidateAfter.! !

!MAWrapper methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
validate: anObject
	"Primitive to validate anObject. Do not call directly, use #validate instead."
	
	(self owner isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self owner isSatisfiedBy: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
value
	self subclassResponsibility.! !

!MAWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:15'!
value: anObject
	self subclassResponsibility.! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAScaffolder subclass: #MADescribedScaffolder
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
description
	^ description! !

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
description: aDescription
	description := aDescription! !

!MADescribedScaffolder methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:14'!
initialize
	super initialize.
	self description: self class defaultContainer.! !

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
initialize
	super initialize.
	self values: IdentityDictionary new.! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
readUsing: aDescription
	^ aDescription isContainer
		ifTrue: [ super readUsing: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				ifAbsentPut: [ aDescription default ] ].! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
values
	^ values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
write: anObject using: aDescription
	^ aDescription isContainer
		ifTrue: [ super write: anObject using: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				put: anObject ].! !

Object subclass: #MAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAVisitor subclass: #MAStreamer
	instanceVariableNames: 'stream objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAStreamer subclass: #MAReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAReader methodsFor: 'streaming' stamp: 'lr 4/18/2005 08:14'!
next
	self subclassResponsibility.! !

MAReader subclass: #MAStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAStreamer class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
on: aStream
	^ self new
		setStream: aStream;
		yourself.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
id
	^ objects last key.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
initialize
	super initialize.
	objects := OrderedCollection new.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
object
	^ objects last value.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
setStream: aStream
	stream := aStream! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:15'!
stream
	^ stream! !

!MAStreamer methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:15'!
visit: aFirstObject with: aSecondObject
	objects addLast: self nextId -> aSecondObject.
	[ self visit: aFirstObject ]
		ensure: [ objects removeLast ].! !

MAStreamer subclass: #MAWriter
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAWriter subclass: #MAStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAWriter methodsFor: 'initialization' stamp: 'lr 4/18/2005 08:15'!
initialize
	super initialize.
	id := 0.! !

!MAWriter methodsFor: 'private' stamp: 'lr 4/18/2005 08:15'!
nextId
	^ 't' , (id := id + 1) asString.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 4/18/2005 08:15'!
nextPut: anObject
	self nextPut: anObject using: anObject description.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 4/18/2005 08:15'!
nextPut: anObject using: aDescription
	self visit: aDescription with: anObject.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/18/2005 08:15'!
visitBlockAccessor: anAccessor
	self stream 
		nextPutAll: anAccessor writeBlock decompile allButFirst allButLast; space; 
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: '.'; cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/18/2005 08:15'!
visitCacadeAccessor: anAccessor
	self visit: anAccessor accessor.
	self visit: anAccessor next.! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 4/18/2005 08:15'!
visitContainer: aDescription
	self stream nextPutAll: self id; nextPutAll: ' := '; nextPutAll: self object class name; nextPutAll: ' basicNew.'; cr.
	aDescription do: [ :each | 
		each isPersistent ifTrue: [
			self 
				visit: each
				with: (each accessor read: self object) ] ].! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 4/18/2005 08:15'!
visitElement: aDescription
	self stream 
		nextPutAll: self id; 
		nextPutAll: ' := '; 
		nextPutAll: aDescription class name; 
		nextPutAll: ' basicNew parseString: ';
		print: (aDescription toString: self object);
		nextPutAll: '.';
		cr.
	self nextPut: aDescription.
	self stream 
		nextPutAll: (aDescription accessor printWrite: self id to: objects allButLast last key);
		cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/18/2005 08:15'!
visitModelAccessor: anAccessor
	self error: anAccessor asString , ' is not implemented.'! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/18/2005 08:15'!
visitSelectorAccessor: anAccessor
	self stream nextPutAll: anAccessor writeSelector; space.! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 4/18/2005 08:15'!
visit: anObject
	anObject acceptMagritte: self.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/18/2005 08:15'!
visitContainer: anObject
	self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/18/2005 08:15'!
visitDescription: anObject! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/18/2005 08:15'!
visitElement: anObject
	self visitDescription: anObject.! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ self name! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 4/18/2005 08:14'!
description
	^ MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asCachedCopy
	^ self shallowCopy.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ self asString.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/18/2005 08:14'!
defaultContainer
	"Return the default description container."
	
	^ MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/18/2005 08:14'!
defaultWrapperClass
	^ MACheckedWrapper! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 4/18/2005 08:14'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^ self class description.! !

!Object methodsFor: '*Magritte-Core-testing' stamp: 'lr 4/18/2005 08:14'!
isDescription
	^ false! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 4/18/2005 08:14'!
query
	"Return a string that represents that represents the receiver and is used as a default value for querying."

	^ self asString! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/18/2005 08:14'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^ aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/18/2005 08:14'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ 'no'! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 4/18/2005 08:14'!
moveDown: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 4/18/2005 08:14'!
moveUp: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
realSubject
	^ super realSubject value.! !

MAProxyObject subclass: #MAModelObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAModelObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
realSubject
	| context index |
	context := thisContext.
	[ context isNil ] whileFalse: [
		index := context receiver class 
			allInstVarNames indexOf: 'wrapper'.
		index isZero ifFalse: [ 
			^ super realSubject 
				value: (context receiver 
					instVarAt: index) model ].
		context := context sender ].
	^ nil.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
on: anObject
	^ self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 4/18/2005 08:14'!
doesNotUnderstand: aMessage
	^ self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isMorph
	^ false! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isNil
	^ self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 4/18/2005 08:14'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
realSubject
	^ realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
realSubject: anObject
	realSubject := anObject! !

SmaCCParser subclass: #MARelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationParser class methodsFor: 'generated-comments' stamp: 'lr 4/17/2005 19:08'!
parserDefinitionComment

	"Start
	: { nil }
	| Expression { #liftFirstValue: } 
	;


# E X P R E S S I O N S

Expression
	: OrExpression { #liftFirstValue: } 
	;

OrExpression
	: OrExpression 'expr1' ""OR"" AndExpression 'expr2' { MAAnyRelation with: expr1 with: expr2 }
	| AndExpression { #liftFirstValue: } 
	;

AndExpression
	: AndExpression 'expr1' ""AND"" NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| AndExpression 'expr1' NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| NotExpression { #liftFirstValue: } 
	;

NotExpression
	: ""NOT"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""-"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""("" Expression 'expr' "")"" { expr }
	| Relation { #liftFirstValue: } 
	; 


# R E L A T I O N S

Relation
	: Accessor 'accessor' UnaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' BinaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' KeywordMessage 'message' { self customize: message with: accessor }
	| LiteralValue 'literal' { MAQueryRelation selector: #matches: with: literal }
	;
	
Accessor
	: UnarySelector 'unary' { MASelectorAccessor selector: unary }
	;
	
UnaryMessage
	: UnarySelector 'unary' { MAAccessorRelation selector: unary }
	;
	
BinaryMessage
	: BinarySelector 'binary' LiteralValue 'literal' { MAAccessorRelation selector: binary with: literal }
	;
	
KeywordMessage
	: KeywordSelector 'keyword' LiteralValue 'literal' { MAAccessorRelation selector: keyword with: literal }
	| KeywordMessage 'message' KeywordSelector 'keyword' LiteralValue 'literal' { message setSelector: keyword argument: literal }
	;


# V A L U E S
	
UnarySelector
	: <unary> 'unary' { unary value asSymbol }
	;
	
BinarySelector
	: <binary> 'binary' { binary value asSymbol }
	;
	
KeywordSelector
	: <keyword> 'keyword' { keyword value asSymbol }
	;

LiteralValue
	: ""true"" { true }
	| ""false"" { false }
	| ""nil"" { nil }
	| <number> 'number' { number value asNumber }
	| <string> 'string' { string value copyFrom: 2 to: string value size - 1 }
	;"! !

!MARelationParser class methodsFor: 'generated-accessing' stamp: 'lr 4/17/2005 19:08'!
scannerClass
	^MARelationScanner! !

!MARelationParser class methodsFor: 'generated-starting states' stamp: 'lr 4/17/2005 19:08'!
startingStateForStart
	^1! !

!MARelationParser methodsFor: 'building' stamp: 'lr 4/18/2005 08:14'!
customize: aRelation with: anAccessor
	(MABlockToRelation includesSelector: aRelation selector) 
		ifFalse: [ self error: aRelation selector , ' is an unknown selector.' ].
	^ aRelation setAccessor: anAccessor.! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForAccessor1: nodes 
	^MASelectorAccessor selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForAndExpression1: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForAndExpression2: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForBinaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForBinarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForKeywordMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForKeywordMessage2: nodes 
	^(nodes at: 1) setSelector: (nodes at: 2) argument: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForKeywordSelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForLiteralValue1: nodes 
	^true! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForLiteralValue2: nodes 
	^false! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForLiteralValue3: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForLiteralValue4: nodes 
	^(nodes at: 1) value asNumber! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForLiteralValue5: nodes 
	^(nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForNotExpression1: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForNotExpression2: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForNotExpression3: nodes 
	^nodes at: 2! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForOrExpression1: nodes 
	^MAAnyRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForRelation1: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForRelation2: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForRelation3: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForRelation4: nodes 
	^MAQueryRelation selector: #matches: with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForStart1: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForUnaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/17/2005 19:08'!
reduceActionForUnarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 4/17/2005 19:08'!
reduceTable
	^#(
#(17 2 #reduceActionForRelation1:)
#(17 2 #reduceActionForRelation2:)
#(17 2 #reduceActionForRelation3:)
#(17 1 #reduceActionForRelation4:)
#(18 1 #reduceActionForUnaryMessage1:)
#(19 2 #reduceActionForBinaryMessage1:)
#(20 2 #reduceActionForKeywordMessage1:)
#(20 3 #reduceActionForKeywordMessage2:)
#(21 1 #reduceActionForLiteralValue1:)
#(21 1 #reduceActionForLiteralValue2:)
#(21 1 #reduceActionForLiteralValue3:)
#(21 1 #reduceActionForLiteralValue4:)
#(21 1 #reduceActionForLiteralValue5:)
#(22 1 #reduceActionForUnarySelector1:)
#(23 1 #reduceActionForBinarySelector1:)
#(24 1 #reduceActionForKeywordSelector1:)
#(25 2 #reduceActionForNotExpression1:)
#(25 2 #reduceActionForNotExpression2:)
#(25 3 #reduceActionForNotExpression3:)
#(25 1 #liftFirstValue:)
#(26 3 #reduceActionForAndExpression1:)
#(26 2 #reduceActionForAndExpression2:)
#(26 1 #liftFirstValue:)
#(27 3 #reduceActionForOrExpression1:)
#(27 1 #liftFirstValue:)
#(28 1 #reduceFor:)
#(29 0 #reduceActionForStart1:)
#(29 1 #liftFirstValue:)
#(32 1 #liftFirstValue:)
#(33 1 #reduceActionForAccessor1:)
)! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 4/17/2005 19:08'!
transitionTable
	^#(
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 69 29 110 30 73 32 77 33)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 81 25 77 33)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 85 25 77 33)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 89 32 77 33)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 30)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 122 10 13 14)
#(2 94 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 102 5 21 6 25 7 29 8 102 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 102 30 77 33)
#(3 101 5 118 9 118 30)
#(2 0 30)
#(2 114 30)
#(3 33 10 105 13 109 14 113 18 117 19 121 20 125 22 129 23 133 24)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 137 9)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 141 25 77 33)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 145 26 77 33)
#(2 66 2 6 7 11 12)
#(2 62 2 6 7 11 12)
#(2 6 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 14 1 14 2 14 3 14 4 14 5 14 6 14 7 14 8 14 9 14 10 14 11 14 12 105 13 149 24 14 30)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 13 2 21 6 25 7 37 11 41 12 153 21)
#(3 13 2 21 6 25 7 37 11 41 12 157 21)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 98 5 21 6 25 7 29 8 98 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 98 30 77 33)
#(3 13 2 21 6 25 7 37 11 41 12 161 21)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
)! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ 'n/a'! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^ value asString , ' ' , each ] ].! !

Notification subclass: #MANotification
	instanceVariableNames: 'wrapper when'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MACommitNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
afterToken
	^ #after! !

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 4/18/2005 08:15'!
beforeToken
	^ #before! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
notifyAfter: aWrapper
	^ self wrapper: aWrapper when: self afterToken.! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
notifyBefore: aWrapper
	^ self wrapper: aWrapper when: self beforeToken! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/18/2005 08:15'!
wrapper: aWrapper when: aSelector
	^ self new
		wrapper: aWrapper;
		when: aSelector;
		signal.! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:14'!
accessor
	^ self wrapper accessor.! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 4/18/2005 08:14'!
description
	^ self wrapper owner.! !

!MANotification methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isAfter
	^ self when = self class afterToken.! !

!MANotification methodsFor: 'testing' stamp: 'lr 4/18/2005 08:14'!
isBefore
	^ self when = self class beforeToken.! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
when
	^ when! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
when: aSymbol
	when := aSymbol! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
wrapper
	^ wrapper! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/18/2005 08:14'!
wrapper: aWrapper
	wrapper := aWrapper! !

MANotification subclass: #MAResetNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MAValidateNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asLabel
	^ 'yes'! !

!Behavior methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/18/2005 08:14'!
asCachedCopy
	^ self! !
MAConstantRelation initialize!
